/*************************************************************************
 *
 * FILE  timer.hpp
 * Copyright (c) 2005, 2006 Daniel Kahlin <daniel@kahlin.net>
 * Written by Daniel Kahlin <daniel@kahlin.net>
 * $Id: timer.hpp,v 1.3 2006-10-20 15:16:38 tlr Exp $
 *
 * DESCRIPTION
 *   Template for C++ header files.
 *
 ******/
#ifndef TIMER_HPP
#define TIMER_HPP

#include <windows.h>
#include "../util/types.hpp"

/*************************************************************************
 *
 * CLASS  Timer
 *
 * DESCRIPTION
 *
 * KNOWN BUGS
 *   none
 *
 ******/
class Timer
{
public:
    Timer() : start_(0), stop_(0) {}
    void start() { start_ = GetTickCount(); }    
    void stop() { stop_ = GetTickCount(); }    
    uint32_t get_time() const { return stop_-start_; }
    double get_time_d() const { return get_time()/1000.0; }

private:
    DWORD start_;
    DWORD stop_;
};


class USleep
{
public:
    USleep()
    {
	LARGE_INTEGER pcfreq;
	QueryPerformanceFrequency(&pcfreq);
	mutime_=static_cast<int>( (double)pcfreq.QuadPart/1000000.0 );
    }

    void usleep(int t)
    {
	LARGE_INTEGER pcnt1,pcnt2;
	int diff=mutime_*t;
	QueryPerformanceCounter(&pcnt1);
	do {
	    QueryPerformanceCounter(&pcnt2);
	} while (pcnt2.QuadPart-pcnt1.QuadPart < diff);
    }
private:
    int mutime_;
};


#endif /* TIMER_HPP */

/* eof */
